# Update Log [![pipeline status](https://gitlab.com/yoginth/update-log/badges/master/pipeline.svg)](https://gitlab.com/yoginth/update-log/commits/master)

[![NPM](https://nodei.co/npm/update-log.png)](https://nodei.co/npm/update-log/)

> Log by overwriting the previous output in the terminal.<br>
> Useful for rendering progress bars, animations, etc.

## Install

```
$ npm install update-log
```


## Usage

```js
const logUpdate = require('update-log');
const frames = ['-', '\\', '|', '/'];
let i = 0;

setInterval(() => {
	const frame = frames[i = ++i % frames.length];

	logUpdate(
`
        ♥♥
   ${frame} unicorns ${frame}
        ♥♥
`
	);
}, 80);
```

## API

### logUpdate(text, ...)

Log to stdout.

### logUpdate.clear()

Clear the logged output.

### logUpdate.done()

Persist the logged output.<br>
Useful if you want to start a new log session below the current one.

### logUpdate.stderr(text, ...)

Log to stderr.

### logUpdate.stderr.clear()
### logUpdate.stderr.done()

### logUpdate.create(stream, [options])

Get a `logUpdate` method that logs to the specified stream.

#### options

Type: `Object`

##### showCursor

Type: `boolean`<br>
Default: `false`

Show the cursor. This can be useful when a CLI accepts input from a user.

```js
// Write output but don't hide the cursor
const log = logUpdate.create(process.stdout, {
	showCursor: true
});
```

## Thanks

- [Sindre Sorhus](https://sindresorhus.com)

## License

MIT © [Yoginth](https://yoginth.ml)
